#!/usr/local/bin/webwork-perl

## $Id: profDownloadPaperCopies.pl,v 1.5 2001/06/18 15:21:51 sam Exp $

####################################################################
# Copyright @ 1995-1998 University of Rochester
# All Rights Reserved
####################################################################


## This file is profChangeDates.pl
## It provides access to utilities for building, correcting and viewing problem sets
##


use lib '.'; use webworkInit; # WeBWorKInitLine
require 5.001;
use strict;


use Global;
use Auth;
use TimeLocal;
use CGI qw(:standard);


# Timing code
use Benchmark;
my $beginTime = new Benchmark;
# end Timing code

# variables global to this file
my ($setNumber,$setHeaderFileName,$probHeaderFileName,$dueDate,$openDate,$answerDate,$problemListref,$problemValueListref,$problemAttemptLimitListref);
my (@problemList,@problemValueList,@problemAttemptLimitList);

#&CGI::ReadParse;
#my %inputs=%main::in;
my $cgi = new CGI;
if( $CGI::VERSION < 2.5 ) {
	die "This version of WeBWorK requires at least version 2.50 of the CGI.pm library";
}
my %inputs = $cgi -> Vars();
my ($classID, $fileName);

# establish environment for this script

    my $Course = $inputs{'course'};
&Global::getCourseEnvironment($Course);


my 	$cgiURL   		        = getWebworkCgiURL($Course);
my $courseScriptsDirectory 	= getCourseScriptsDirectory($Course);
my $databaseDirectory 		= getCourseDatabaseDirectory($Course);
my $htmlURL       			= getCourseHtmlURL($Course);
my $scriptDirectory   		= getWebworkScriptDirectory($Course);
my $templateDirectory       = getCourseTemplateDirectory;

require "${scriptDirectory}$Global::DBglue_pl";
require "${scriptDirectory}$Global::classlist_DBglue_pl";
require "${scriptDirectory}$Global::FILE_pl";
require "${scriptDirectory}$Global::HTMLglue_pl";

# log access
	&Global::log_info('', query_string);

&webDatePage;

# begin Timing code
my $endTime = new Benchmark;
&Global::logTimingInfo($beginTime,$endTime,"profChangeDates.pl",$inputs{'course'},$inputs{'course'});
# end Timing code
exit;

#####################################END######################################

sub webDatePage {
#   verify the identity of the user.
	my $keyFile = &Global::getCourseKeyFile($inputs{'course'});
	&verify_key($inputs{'user'}, $inputs{'key'}, "$keyFile", $inputs{'course'});
	my $permissionsFile = &Global::getCoursePermissionsFile($inputs{'course'});
	my $permissions = &get_permissions($inputs{'user'}, $permissionsFile);
	if ($permissions != $Global::instructor_permissions ) {
		print "permissions = $permissions instructor_permissions= $Global::instructor_permissions\n";
		print &html_NO_PERMISSION;
		exit(0);
		}

    else  {
		print &htmlTOP("Download Paper copies");
        # print navigation buttons
        print qq!
        <A HREF="${cgiURL}profLogin.pl?user=$inputs{'user'}&amp;key=$inputs{'key'}&amp;course=$inputs{'course'}">
        <IMG SRC="${Global::upImgUrl}" align="right" BORDER=1 ALT="[Up]"></A><p>
        !;
		$setNumber=$inputs{'setNo'};
		&printForms($setNumber);
		print &htmlBOTTOM("profDownloadPaperCopies.pl", \%inputs);
    }


}





sub printForms {
    my ($setNumber) = @_;

#	Problem Set Number $SetNumber -- psvn: $psvn -- for $StudentLastName, $StudentFirstName<BR>
#############################################
# FORM for downloading postscript versions
#############################################

	my $format = $inputs{'format'};  #alph, section, or recitation

	my (@tempLoginList,$login_name);

	if ($format eq 'section') {
		@tempLoginList = @{getAllLoginNamesSortedBySectionThenByName()};
	}
	elsif ($format eq 'recitation') {
		@tempLoginList = @{getAllLoginNamesSortedByRecitationThenByName()};
	}
	else {
		@tempLoginList = @{getAllLoginNamesSortedByName()};
	}

	my %loginHashForSet = %{getLoginHashForSet($setNumber)};
	my @loginList = ();

	foreach $login_name (@tempLoginList) {
		push @loginList, $login_name if defined $loginHashForSet{$login_name};
	}

	@tempLoginList =();

	print qq!
		<FORM action="${Global::cgiWebworkURL}welcomeAction.pl">
		<HR NOSHADE><H3>Download paper copies of set $setNumber for selected students:</H3>\n
		This will produce a large file containing every selected student's version of the problem set.  Also this
		may take quite a while for large number of students.  Selecting TeX format and then TeX'ing the resulting TeX
		file on your local computer may be much more efficient.  <BR>!;

# enter available individual logins
	print qq!<BR>\n<SELECT Name='local_psvns' Size =10 multiple>\n!;
	my ($lastName, $firstName, $studentID, $local_psvn, $section, $recitation, $label);
#	foreach $local_psvn (@local_psvns) {
	foreach $login_name (@loginList) {
		attachCLRecord($login_name);
		$local_psvn = $loginHashForSet{$login_name};
		attachProbSetRecord($local_psvn);
											   ## student
		$lastName		= CL_getStudentLastName($login_name);
		$firstName		= CL_getStudentFirstName($login_name);
		$studentID		= CL_getStudentID($login_name);
		$section		= CL_getClassSection($login_name);
		$recitation		= CL_getClassRecitation($login_name);

		if ($format eq 'section') {
		$label = ", $section";
		}
		elsif ($format eq 'recitation') {
		$label = ", $recitation";
		}
		else {
		$label = '';
		}
		$label = "$lastName, $firstName, $studentID, $login_name". $label;
		print "   <OPTION VALUE = \"$local_psvn\">$label \n";
		}

		print qq! \n</SELECT>\n!;


	print qq!
		<INPUT TYPE='HIDDEN' NAME='action' VALUE='Get_all_copies'>
		<INPUT TYPE="HIDDEN" NAME="setNo" VALUE="$setNumber">
		<INPUT TYPE='HIDDEN' NAME='probSetKey'  VALUE=-1><BR>
		<B>Download Type:</B> <INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"ps\" CHECKED><B>postscript</B> format
		<INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"pdf\"><B>pdf</B> format
		<INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"TeX\"><B>TeX</B> format
		<INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"dvi\"><B>DVI</B> format<BR>

		<INPUT TYPE=CHECKBOX NAME=\"ShowAns\" VALUE=\"1\"> Show answers in hard copy.<BR>

	!;

	print &sessionKeyInputs(\%inputs);

	print qq!
		<br><input type="submit" value="Download Sets">
		</FORM>
	!;
}