#!/usr/local/bin/webwork-perl

################################################################
#  Copyright @1995-2002 by Michael E. Gage, Arnold K. Pizer and
#  WeBWorK at the University of Rochester. All rights reserved.
################################################################

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine
use Global;
## pngPrecreateSet.pl
##
## pre-creates dvipng output for each student for a problem set
## so that WeBWorK doesn't have to run dvipng in processProblems

## NOTE: problem set has to be built before precreating...

## this is called with arguments classID setdefinitionfile...
## e.g. pngPrecreateSet.pl demoCourse set1.def

my($courseID, $fileName, $lowerLimit, $upperLimit) = @ARGV;

if( (@ARGV < 2) or (@ARGV > 4) ) {
	print "\nSyntax is: pngPrecreateSet.pl course_name set_definition_filename    or\n";
	print "           pngPrecreateSet.pl course_name set_definition_filename lowerLimit   or\n";
	print "           pngPrecreateSet.pl course_name set_definition_filename lowerLimit upperLimit\n\n";
	print "       (e.g. pngPrecreateSet.pl demoCourse set1.def    or\n";
	print "       (e.g. pngPrecreateSet.pl demoCourse set1.def  30000  or\n";
	print "       (e.g. pngPrecreateSet.pl demoCourse set1.def  30000   60000\n\n";

	print "Problems are pre created for all psvn's between lower and upper limits if the limits\n";
	print "  are given.\n\n";
	exit(0);
  }

my $scriptDirectory         = getWebworkScriptDirectory();

require "${scriptDirectory}precreate.pl";

precreate('set', 'HTML_dpng', $courseID, $fileName, $lowerLimit, $upperLimit);