// Copyright 1997 by Richard Mansfield; see the file COPYING.

public class RungeKutta implements SingleStep {
	double xval=0, yval=0, tval=0, step=.01, localstep=.01;
	
	RungeKutta(double x, double y, double t, double h){
		xval = x;
		yval = y;
		tval = t;
		step = h;
	}
	
	public void initialize (double x, double y, double t, double h) {
		xval = x;
		yval = y;
		tval = t;
		step = h;
	}
	

	public Rthree next() {
		//See the comments in Euler.java.
		double L1 = newphase.c.f.value(xval, yval, tval);
		double M1 = newphase.c.g.value(xval, yval, tval);
		double Mod = Math.sqrt(L1*L1+M1*M1);
		if (Mod < 1) Mod = 1;
		localstep = step/Mod;
		double h = localstep;
		double x1 = xval + h*L1/2;
		double y1 = yval + h*M1/2;
		double t1 = tval + h/2;
		double L2 = newphase.c.f.value(x1, y1, t1);
		double M2 = newphase.c.g.value(x1, y1, t1);
		x1 = xval + h*L2/2;
		y1 = yval + h*M2/2;
		double L3 = newphase.c.f.value(x1, y1, t1);
		double M3 = newphase.c.g.value(x1, y1, t1);
		x1 = xval + h*L3;
		y1 = yval + h*M3;
		tval = tval + h;
		double L4 = newphase.c.f.value(x1, y1, tval);
		double M4 = newphase.c.g.value(x1, y1, tval);
		xval = xval + h*(L1+2*L2+2*L3+L4)/6;
		yval = yval + h*(M1+2*M2+2*M3+M4)/6;
		return new Rthree(xval, yval, tval);
	}
}
