
// Copyright 1997 by Richard Mansfield; see the file COPYING.

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class Solutions extends Canvas implements MouseMotionListener{
	Image pad;
	Graphics gpad;
	XYTFunction f, g;
	Rtwo initf, initb;
	Color orbitcolor = Color.orange;
        RealFrame realLimits = new RealFrame();
	Rtwo movie[][] = new Rtwo[realLimits.stepcount+1][realLimits.stepcount+1];
	Rtwo inits[][] = new Rtwo[realLimits.stepcount+1][2];
	int	cursorx,
		cursory,
		cursort;
	
Solutions() {
	setBackground(newphase.back);
	this.addMouseMotionListener(this);
}

public void mouseDragged(MouseEvent e) {}
public void mouseMoved(MouseEvent e) {
	int x = e.getX();
	int y = e.getY();
	Graphics hg = getGraphics();
        if (hg == null) return;
     	Rtwo point = realLimits.toRtwo(x, y);
     	hg.setColor(newphase.back);
     	hg.fillRect(0,0,200,25);
     	hg.setColor(newphase.c.orbitcolor);
        hg.drawString("x= "+point.xcord, 2, 12);
        hg.drawString("y= "+point.ycord, 2, 24);
	hg.dispose();
}

public void setBounds(int x, int y, int width, int height) {
	super.setBounds(x, y, width, height);
	pad = createImage(width, height);
	gpad = pad.getGraphics();
	realLimits.realSetup(width, height);
	realLimits.setframe(-30, 30, -3, 3);
	clear();
}

public void drawAxes() {
	Point p = realLimits.fromRtwo(0, 0);
	gpad.drawLine(p.x, 0, p.x, getSize().height-1);
	gpad.drawLine(0, p.y, getSize().width-1, p.y);
}

public void clear() {
	initf=null;initb=null;
	gpad.setColor(newphase.back);
	gpad.fillRect(0,0,getSize().width-1, getSize().height-1);
	gpad.setColor(newphase.fore);
	drawAxes();
	repaint();
	}

void cursor (double x, double y, double t) {
	Point p = realLimits.fromRtwo(t, x);
	Point q = realLimits.fromRtwo(t, y);
	cursorx = p.y;
	cursory = q.y;
	cursort = p.x;
}

void next(double x, double y, double t) {
	Point p = realLimits.fromRtwo(t, x);
	Point q = realLimits.fromRtwo(t, y);
	gpad.setColor(Color.magenta);
	gpad.drawLine(cursort, cursorx, p.x, p.y);
	gpad.setColor(Color.cyan);
	gpad.drawLine(cursort, cursory, q.x, q.y);
	cursorx = p.y;
	cursory = q.y;
	cursort = p.x;
}
	

//Overwrite update to cut out default clearscreen.	
public void update(Graphics g) {
	paint(g);
}

public void setframe(double xmin, double xmax, double ymin, double ymax,
			double tmin, double tmax) {
	double tempmin = xmin;
	if (ymin < xmin) tempmin = ymin;
	double tempmax = xmax;
	if (ymax > xmax) tempmax = ymax;
	realLimits.setframe(tmin, tmax, tempmin, tempmax);
	clear();
}
	
/*
public boolean mouseMove(Event e, int x, int y) {
	Graphics hg = getGraphics();
        if (hg == null) return true;
     	Rtwo point = realLimits.toRtwo(x, y);
     	hg.setColor(newphase.back);
     	hg.fillRect(0,0,200,25);
     	hg.setColor(newphase.c.orbitcolor);
        hg.drawString("x= "+point.xcord, 2, 12);
        hg.drawString("y= "+point.ycord, 2, 24);
	hg.dispose();
        return true;
	}

*/
public void paint(Graphics g) {
	if (pad == null){
		pad = createImage(getSize().width, getSize().height);
		// pad is the off-screen buffer.
		gpad = pad.getGraphics();
		realLimits.realSetup(getSize().width, getSize().height);
		clear();
	}
	g.drawImage(pad, 0, 0, null);
     }


}

