// Put the expression evaluator through its paces.

// Sample usage:

// $ java expr.Test '3.14159 * x^2' 0 4 1
// 0
// 3.14159
// 12.5664
// 28.2743
// 50.2654
//
// $ java expr.Test 'sin (pi/4 * x)' 0 4 1
// 0
// 0.707107
// 1
// 0.707107
// 1.22461e-16

package expr;

public class Test {
  public static void main (String[] args) {

    Expr expr;
    try { expr = Parser.parse (args [0]); }
    catch (Syntax_error e) {
      System.err.println ("Syntax error: " + e);
      return;
    }

    double low  = Double.valueOf (args [1]).doubleValue ();
    double high = Double.valueOf (args [2]).doubleValue ();
    double step = Double.valueOf (args [3]).doubleValue ();
      
    Variable x = Variable.make ("x");
    Variable.make ("pi").set_value (Math.PI);

    for (double xval = low; xval <= high; xval += step) {
      x.set_value (xval);
      System.out.println (expr.value ());
    }
  }
}
