// Copyright 1997 by Richard Mansfield; see the file COPYING.

//<applet code=newphase.class width=600 height=150> </applet>
// Draws phase portrait of 2x2 autonomous system. On a double
// buffered canvas.

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class newphase extends Applet
		implements ActionListener, ItemListener {
// mycanvas is a double buffered canvas.
//text1 is the string giving x'.
//text2 is y'.
//realLimits sets up the canvas as a window in R^2 and has methods to
//do the conversions between pixel coordinates and real coordinates.
//The SingleStep interface is implemented with the various single step
//methods such as Euler or Runge-Kutta.

	static myCanvas c;
	static Solutions d;
        static TextField text1 = new TextField("-0.1*x-y", 30);
        static TextField text2 = new TextField("x", 30);
        static SingleStep stepper = new RungeKutta(0,0, 0, .01);
        static int	mesh=10,
        		level=5;
        Frame	pplane;
	Frame	splane;
	Checkbox chklines;
	Checkbox chkshow;

//FB
	static Color back = Color.white;
	static Color fore = Color.pink;
        static Frame		setframe = new Frame("Choose Limits");
	static TextField	xminField = new TextField("-3", 5);
	static TextField	xmaxField = new TextField("3", 5);
	static TextField	yminField = new TextField("-3", 5);
	static TextField	ymaxField = new TextField("3", 5);
	static TextField	tminField = new TextField("-30", 5);
	static TextField	tmaxField = new TextField("30", 5);
//

public void init() {
    //Typical layout shit to compensate for having no decent
    //Layout manager in Java.
    	setLayout( new BorderLayout());
	Panel p = new Panel();
        add("South", p);
        p.setLayout ( new BorderLayout());
        Panel p1 = new Panel();
        p1.setLayout( new BorderLayout());
        Panel p11 = new Panel();
        Panel p12 = new Panel();
        p11.add(new Label("x' = "));
        p11.add(text1);
        p12.add(new Label("y' = "));
        p12.add(text2);
        p1.add("North", p11);
        p1.add("South", p12);
        p.add("North", p1);
        Panel p2 = new Panel();
        p.add("Center", p2);
        Button breset = new Button("reset");
        breset.addActionListener(this);
        p2.add (breset);
        Button bwindow = new Button("window");
        bwindow.addActionListener(this);
	p2.add (bwindow);
	Button goback = new Button("<<");
	goback.addActionListener(this);
	p2.add (goback);
	Button goforth = new Button(">>");
	goforth.addActionListener(this);
	p2.add (goforth);
	Button bundo = new Button("undo");
	bundo.addActionListener(this);
	p2.add (bundo);
	Button bnullclines = new Button("nullclines");
	bnullclines.addActionListener(this);
	p2.add (bnullclines);
	chklines = new Checkbox("line elements",null,true);
	chklines.addItemListener(this);
	p2.add (chklines);
	Panel p3 = new Panel();
	p.add("South",p3);
        Choice kleur = new Choice();
        kleur.addItem("Black");
        kleur.addItem("Blue");
        kleur.addItem("Orange");
        kleur.addItem("Yellow");
	kleur.addItem("Green");
	kleur.addItem("Red");
	kleur.addItemListener(this);
        p3.add(kleur);
	Choice example = new Choice();
	example.addItem("Examples");
	example.addItem("Van der Pol");
	example.addItem("Volterra");
	example.addItem("Predator-prey");
	example.addItem("Pendulum");
	example.addItem("Teddy bear");
	example.addItemListener(this);
	p3.add(example);
	chkshow = new Checkbox("show solutions?",null,true);
	chkshow.addItemListener(this);
	p3.add (chkshow);
	c = new myCanvas();
	setframe.setLayout( new BorderLayout());
	Panel limits = new Panel();
	limits.setLayout( new GridLayout(4,3));
	limits.add(new Label(""));
	limits.add(new Label("min"));
	limits.add(new Label("max"));
	limits.add(new Label("     x"));
	limits.add(xminField);
	limits.add(xmaxField);
	limits.add(new Label("     y"));
	limits.add(yminField);
	limits.add(ymaxField);
	limits.add(new Label("     t"));
	limits.add(tminField);
	limits.add(tmaxField);
	setframe.add("North", limits);
	Panel okbutton = new Panel();
	okbutton.setSize(20, 15);
	Button bok = new Button("ok");
	bok.addActionListener(this);
	okbutton.add(bok);
	setframe.add("South", okbutton);
	setframe.setSize(300,200);
	d = new Solutions();
	if (pplane == null)  {
	        pplane = new Frame("Phase Portrait");
	    	pplane.setLayout( new BorderLayout());
		pplane.add("Center", c);
		pplane.setSize(400, 400);
	}
	if (splane == null) {
		splane = new Frame("Solutions");
	   	splane.setLayout( new BorderLayout());
		splane.add("Center", d);
		splane.setSize(450, 150);
	}
    }

public void start() {
	pplane.setVisible(true);
	pplane.repaint();
	if (c.plot_solutions) {
		splane.setVisible(true);
		splane.repaint();
	}
}

public void stop() {
	pplane.setVisible(false);
	splane.setVisible(false);
}

public void itemStateChanged(ItemEvent e) {
	if (e.getItemSelectable() instanceof Choice) {
		if ("Black".equals ((String)e.getItem()))
			{c.orbitcolor = Color.black;}
		if ("Orange".equals ((String)e.getItem()))
			{c.orbitcolor = Color.orange;}
		if ("Yellow".equals ((String)e.getItem()))
			{c.orbitcolor = Color.yellow;}
		if ("Green".equals ((String)e.getItem()))
			{c.orbitcolor = Color.green;}
		if ("Red".equals ((String)e.getItem()))
			{c.orbitcolor = Color.red;}
		if ("Blue".equals ((String)e.getItem()))
			{c.orbitcolor = Color.blue;}
		if ("Van der Pol".equals((String)e.getItem())){
			text1.setText("y");
			text2.setText("(1-x^2)*y-x");
			//((Choice)(e.target)).select("Examples");
			c.setframe(-3,3,-3,3,0,0);
			d.setframe(-3,3,-3,3,-30,30);
		}
		if ("Volterra".equals((String)e.getItem())){
			text1.setText("x-x*y");
			text2.setText("-y+x*y");
			//((Choice)(e.target)).select("Examples");
			c.setframe(0,3,0,3,0,0);
			d.setframe(0,3,0,3,-30, 30);
		}
		if ("Predator-prey".equals((String)e.getItem())){
			text1.setText("5*(1-x/3.2-2*y/(1+x))*x");
			text2.setText("y*(x-1)/(1+x)");
			//((Choice)(e.target)).select("Examples");
			c.setframe(0,3,0,1.5,0,0);
			d.setframe(0,3,0,1.5,-30,30);
		}
		if ("Pendulum".equals((String)e.getItem())){
			text1.setText("y");
			text2.setText("-sin(x)");
			//((Choice)(e.target)).select("Examples");
			c.setframe(-6,6,-3,3,0,0);
			d.setframe(-6,6,-3,3,-30,30);
		}
		if ("Teddy bear".equals((String)e.getItem())){
			text1.setText("sin(y)-2*sin(x^2)*sin(2*y)");
			text2.setText("-cos(x)-2*x*cos(x^2)*cos(2*y)");
			//((Choice)(e.target)).select("Examples");
			c.setframe(-3,3,-3,3,0,0);
			d.setframe(-3,3,-3,3,-30,30);
		}
	}
	if (e.getItemSelectable() instanceof Checkbox){
		Checkbox ee = (Checkbox)e.getItemSelectable();
		if (ee.getLabel().equals("line elements")) {
			c.plotslopes = ee.getState();
			c.replay();
		}
		else {
		c.plot_solutions = ee.getState();
		if (c.plot_solutions) splane.setVisible(true);
		else {d.clear(); splane.setVisible(false);}
		}
	}

}

public void actionPerformed(ActionEvent e){
		if ("ok".equals(e.getActionCommand())){
		try{
		double xmin =
		  Double.valueOf(newphase.xminField.getText()).doubleValue();
		double ymin =
		  Double.valueOf(newphase.yminField.getText()).doubleValue();
		double xmax =
		  Double.valueOf(newphase.xmaxField.getText()).doubleValue();
		double ymax =
		  Double.valueOf(newphase.ymaxField.getText()).doubleValue();
		double tmin =
		  Double.valueOf(newphase.tminField.getText()).doubleValue();
		double tmax =
		  Double.valueOf(newphase.tmaxField.getText()).doubleValue();
		if (xmax < xmin + .000001) {
			double temp = xmin + .000001;
			xmin = xmax;
			xmax = temp;
		}
		if (ymax < ymin + .000001) {
			double temp = ymin + .000001;
			ymin = ymax;
			ymax = temp;
		}
		if (tmax < tmin + .000001) {
			double temp = tmin + .000001;
			tmin = tmax;
			tmax = temp;
		}
		newphase.c.setframe(xmin, xmax, ymin, ymax, tmin, tmax);
		newphase.d.setframe(xmin, xmax, ymin, ymax, tmin, tmax);
		setframe.setVisible(false);
		}
		catch (NumberFormatException error) {
			System.out.println("Number Format Exception");
		}

		}
    		if ("reset".equals(e.getActionCommand())) {c.clear();}
    		if ("window".equals(e.getActionCommand())) setframe.setVisible(true);
		if (">>".equals(e.getActionCommand())){
			c.goforth = true;
			c.forwardLoop();
			c.record();
			c.repaint();
			d.repaint();
			}
		if ("<<".equals(e.getActionCommand())){
			c.goforth = false;
			c.backwardLoop();
			c.record();
			c.repaint();
			d.repaint();
			}
		if ("undo".equals(e.getActionCommand())) c.undo();
		if ("nullclines".equals(e.getActionCommand())) {
				c.gpad.setColor(Color.magenta);
				c.drawBoxes(c.f);
				c.gpad.setColor(Color.cyan);
				c.drawBoxes(c.g);
				c.gpad.setColor(back);
				c.repaint();

		}
}

}

