/*    $Id: Function.java,v 1.1 2002/09/02 05:39:35 gage Exp $
**
**
**************************************************************************
**    Copyright (C) 1996 David Wanqian Liu
**                       davidliu@mti.sgi.com
**                       http://reality.sgi.com/exmployees/davidliu_mti
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
*/


package expression;



/**
  Abstract class type for functions.
  Each function needs to specify the number of arguments in its variable
  list. The Function prototype can take at most two arguments. Functions
  with more arguments can be represented by multiple function pairs.
  */
public abstract class Function {
  /**
    Number of arguments the function can take
    */
  public int numArgs;

  /**
    Apply function to a single argument.
    */
  public abstract double apply(double a);

  /**
    Apply function to two arguments.
    */
  public abstract double apply(double a, double b);

  /**
    Return the string representation of the function.
    */
  public abstract String toString();
}
