/*    $Id: Variable.java,v 1.1 2002/09/02 05:39:36 gage Exp $
**
**
**************************************************************************
**    Copyright (C) 1996 David Wanqian Liu
**                       davidliu@mti.sgi.com
**                       http://reality.sgi.com/exmployees/davidliu_mti
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
*/


package expression;



/**
  An variable in an expression.
  */  
public class Variable {
  /**
    The global variable X.
    */
  public final static Variable X = new Variable("X");

  /**
    The global variable Y.
    */
  public final static Variable Y = new Variable("Y");

  /**
    The global variable Z.
    */
  public final static Variable Z = new Variable("Z");

  /**
    The global variable PI.
    */
  public final static Variable PI = new Variable("PI", 3.14159265358979323846);

  /**
    The global variable E.
    */
  public final static Variable E = new Variable("E", 2.7182818284590452354);
  
  /**
    Current value of a variable.
    */
  public double val;

  String nameStr;

  /**
    Create a default variable without a name.
    */
  public Variable() {
    nameStr = "";
    val = 0.0;
  }


  /**
    Create a variable with a name.
    */
  public Variable(String str) {
    nameStr = str;
    val = 0.0;
  }


  /**
    Create a variable with a name and its value.
    */
  public Variable(String str, double v) {
    nameStr = str;
    val = v;
  }

  /**
    Returns the string representation of the variable.
    */
  public String toString() {
    return nameStr;
  }
}
